diff -ruN freeswan-1.5.orig/pluto/whack.c freeswan-1.5/pluto/whack.c
--- freeswan-1.5.orig/pluto/whack.c	Sun Jun 18 17:20:35 2000
+++ freeswan-1.5/pluto/whack.c	Thu Oct  5 07:05:59 2000
@@ -1,4 +1,6 @@
 /* command interface to Pluto
+ *
+ * Modified by Luc Lanthier based on work from:
  * Copyright (C) 1997 Angelos D. Keromytis.
  * Copyright (C) 1998, 1999  D. Hugh Redelmeier.
  *
@@ -77,6 +79,10 @@
 	    " [--authenticate]"
 	    " [--tunnel]"
 	    " [--pfs]"
+#ifdef OPENSSL
+	    " [--openssl]"
+#endif
+
 	    " \\\n   "
 	    " [--ikelifetime <seconds>]"
 	    " [--ipseclifetime <seconds>]"
@@ -84,6 +90,14 @@
 	    " [--reykeymargin <seconds>]"
 	    " [--reykeyfuzz <percentage>]"
 	    " [--keyingtries <count>]"
+#ifdef OPENSSL
+	    " \\\n   "
+	    " [--certfile <file name>]"
+	    " [--certopts <[!]opt1,[!]opt2,...,[!]optN>]"
+	    " [--peerfile <file name>]"
+	    " [--keyfile <file name>]"
+	    " [--certpath <file name>]"
+#endif
 	    "\n\n"
 	"routing: whack"
 	    " (--route | --unroute)"
@@ -158,47 +172,44 @@
 {
     if (ugh != NULL)
     {
-	char buf[120];
-
-	snprintf(buf, sizeof(buf), "%s \"%s\"", ugh, this);
-	diag(buf);
+      if (this == NULL)
+      {
+          diag(ugh);
+      }
+      else
+      {
+		char buf[120]; /* arbitrary limit */
+
+		snprintf(buf, sizeof(buf), "%s \"%s\"", ugh, this);
+		diag(buf);
+	  }
     }
 }
 
 /* complex combined operands return one of these enumerated values
- * Note: we are close to the limit of 32 flags in an unsigned long!
+ * Note: these become flags in an lset_t.  Since there are more than
+ * 32, we partition them into:
+ * - OPT_* options (most random options)
+ * - DBGOPT_* option (DEBUG options)
+ * - CD_* options (Connection Description options)
  */
 enum {
     OPT_CTLBASE,
     OPT_NAME,
 
-#   define OPT_CD_FIRST OPT_TO	/* first connection description */
-    OPT_TO,
-    OPT_HOST,	/* first per-end */
-    OPT_ID,
-    OPT_IKEPORT,
-    OPT_NEXTHOP,
-    OPT_CLIENT,
-    OPT_UPDOWN,	/* last per-end */
-
-#   define OPT_POLICY_FIRST  OPT_PSK
-    OPT_PSK,	/* same order as POLICY_* */
-    OPT_RSASIG,	/* same order as POLICY_* */
-    OPT_ENCRYPT,	/* same order as POLICY_* */
-    OPT_AUTHENTICATE,	/* same order as POLICY_* */
-    OPT_TUNNEL,	/* same order as POLICY_* */
-    OPT_PFS,	/* same order as POLICY_* */
-
-    OPT_IKELIFETIME,
-    OPT_IPSECLIFETIME,
-    OPT_RKMARGIN,
-    OPT_RKFUZZ,
-    OPT_KTRIES,
-#   define OPT_CD_LAST OPT_KTRIES	/* last connection description */
+	OPT_CD,
 
     OPT_KEYID,
     OPT_PUBKEYRSA,
 
+#ifdef OPENSSL
+    OPT_CERTFILE,
+    OPT_CERTOPTS,
+    OPT_PEERFILE,
+    OPT_KEYFILE,
+    OPT_CERTPATH,
+#endif
+
     OPT_ROUTE,
     OPT_UNROUTE,
 
@@ -210,21 +221,56 @@
     OPT_STATUS,
     OPT_SHUTDOWN,
 
-    OPT_ASYNC
+    OPT_ASYNC,
+#   define OPT_LAST OPT_ASYNC  /* last "normal" option */
+
+/* Connection Description options -- segregated */
+
+#   define CD_FIRST CD_TO      /* first connection description */
+    CD_TO,
+    CD_HOST,   /* first per-end */
+    CD_ID,
+    CD_IKEPORT,
+    CD_NEXTHOP,
+    CD_CLIENT,
+    CD_UPDOWN, /* last per-end */
+
+#   define CD_POLICY_FIRST  CD_PSK
+    CD_PSK,    /* same order as POLICY_* */
+#ifndef OPENSSL
+    CD_RSASIG, /* same order as POLICY_* */
+#else
+    CD_OPENSSL, /* same order as POLICY_* */
+#endif
+    CD_ENCRYPT,        /* same order as POLICY_* */
+    CD_AUTHENTICATE,   /* same order as POLICY_* */
+    CD_TUNNEL, /* same order as POLICY_* */
+    CD_PFS,    /* same order as POLICY_* */
+
+    CD_IKELIFETIME,
+    CD_IPSECLIFETIME,
+    CD_RKMARGIN,
+    CD_RKFUZZ,
+    CD_KTRIES
+#   define CD_LAST CD_KTRIES   /* last connection description */
+
 
 #ifdef DEBUG	/* must be last so others are less than 32 to fit in lset_t */
+#   define DBGOPT_FIRST DBGOPT_NONE
     ,
-    OPT_DEBUG_NONE,
-    OPT_DEBUG_ALL,
+    DBGOPT_NONE,
+    DBGOPT_ALL,
 
-    OPT_DEBUG_RAW,	/* same order as DBG_* */
-    OPT_DEBUG_CRYPT,	/* same order as DBG_* */
-    OPT_DEBUG_PARSING,	/* same order as DBG_* */
-    OPT_DEBUG_EMITTING,	/* same order as DBG_* */
-    OPT_DEBUG_CONTROL,	/* same order as DBG_* */
-    OPT_DEBUG_KLIPS,	/* same order as DBG_* */
-    OPT_DEBUG_PRIVATE	/* same order as DBG_* */
+    DBGOPT_RAW,	/* same order as DBG_* */
+    DBGOPT_CRYPT,	/* same order as DBG_* */
+    DBGOPT_PARSING,	/* same order as DBG_* */
+    DBGOPT_EMITTING,	/* same order as DBG_* */
+    DBGOPT_CONTROL,	/* same order as DBG_* */
+    DBGOPT_KLIPS,	/* same order as DBG_* */
+    DBGOPT_PRIVATE	/* same order as DBG_* */
+#   define DBGOPT_LAST DBGOPT_PRIVATE
 #endif
+
 };
 
 #define OPTION_OFFSET	256	/* to get out of the way of letter options */
@@ -242,30 +288,6 @@
     { "ctlbase", required_argument, NULL, OPT_CTLBASE + OO },
     { "name", required_argument, NULL, OPT_NAME + OO },
 
-    { "to", no_argument, NULL, OPT_TO + OO },
-
-    { "host", required_argument, NULL, OPT_HOST + OO },
-    { "id", required_argument, NULL, OPT_ID + OO },
-    { "ikeport", required_argument, NULL, OPT_IKEPORT + OO + NUMERIC_ARG },
-    { "nexthop", required_argument, NULL, OPT_NEXTHOP + OO },
-    { "client", required_argument, NULL, OPT_CLIENT + OO },
-    { "updown", required_argument, NULL, OPT_UPDOWN + OO },
-
-    { "psk", no_argument, NULL, OPT_PSK + OO },
-    { "rsasig", no_argument, NULL, OPT_RSASIG + OO },
-
-    { "encrypt", no_argument, NULL, OPT_ENCRYPT + OO },
-    { "authenticate", no_argument, NULL, OPT_AUTHENTICATE + OO },
-    { "tunnel", no_argument, NULL, OPT_TUNNEL + OO },
-    { "pfs", no_argument, NULL, OPT_PFS + OO },
-
-    { "ikelifetime", required_argument, NULL, OPT_IKELIFETIME + OO + NUMERIC_ARG },
-    { "ipseclifetime", required_argument, NULL, OPT_IPSECLIFETIME + OO + NUMERIC_ARG },
-    { "rekeymargin", required_argument, NULL, OPT_RKMARGIN + OO + NUMERIC_ARG },
-    { "rekeywindow", required_argument, NULL, OPT_RKMARGIN + OO + NUMERIC_ARG },	/* OBSOLETE */
-    { "rekeyfuzz", required_argument, NULL, OPT_RKFUZZ + OO + NUMERIC_ARG },
-    { "keyingtries", required_argument, NULL, OPT_KTRIES + OO + NUMERIC_ARG },
-
     { "keyid", required_argument, NULL, OPT_KEYID + OO },
     { "pubkeyrsa", required_argument, NULL, OPT_PUBKEYRSA + OO },
 
@@ -282,18 +304,56 @@
 
     { "asynchronous", no_argument, NULL, OPT_ASYNC + OO },
 
+/* options for a connection description */
+    { "to", no_argument, NULL, CD_TO + OO },
+
+    { "host", required_argument, NULL, CD_HOST + OO },
+    { "id", required_argument, NULL, CD_ID + OO },
+    { "ikeport", required_argument, NULL, CD_IKEPORT + OO + NUMERIC_ARG },
+    { "nexthop", required_argument, NULL, CD_NEXTHOP + OO },
+    { "client", required_argument, NULL, CD_CLIENT + OO },
+    { "updown", required_argument, NULL, CD_UPDOWN + OO },
+
+    { "psk", no_argument, NULL, CD_PSK + OO },
+#ifndef OPENSSL
+    { "rsasig", no_argument, NULL, CD_RSASIG + OO },
+#else
+    { "rsasig", no_argument, NULL, CD_OPENSSL + OO },
+    { "openssl", no_argument, NULL, CD_OPENSSL + OO },
+#endif
+
+    { "encrypt", no_argument, NULL, CD_ENCRYPT + OO },
+    { "authenticate", no_argument, NULL, CD_AUTHENTICATE + OO },
+    { "tunnel", no_argument, NULL, CD_TUNNEL + OO },
+    { "pfs", no_argument, NULL, CD_PFS + OO },
+
+    { "ikelifetime", required_argument, NULL, CD_IKELIFETIME + OO + NUMERIC_ARG },
+    { "ipseclifetime", required_argument, NULL, CD_IPSECLIFETIME + OO + NUMERIC_ARG },
+    { "rekeymargin", required_argument, NULL, CD_RKMARGIN + OO + NUMERIC_ARG },
+    { "rekeywindow", required_argument, NULL, CD_RKMARGIN + OO + NUMERIC_ARG },	/* OBSOLETE */
+    { "rekeyfuzz", required_argument, NULL, CD_RKFUZZ + OO + NUMERIC_ARG },
+    { "keyingtries", required_argument, NULL, CD_KTRIES + OO + NUMERIC_ARG },
+
+#ifdef OPENSSL
+    { "certfile", required_argument, NULL, OPT_CERTFILE + OO },
+    { "certopts", required_argument, NULL, OPT_CERTOPTS + OO },
+    { "peerfile", required_argument, NULL, OPT_PEERFILE + OO },
+    { "keyfile", required_argument, NULL, OPT_KEYFILE + OO },
+    { "certpath", required_argument, NULL, OPT_CERTPATH + OO },
+#endif
+
 #ifdef DEBUG
-    { "debug-none", no_argument, NULL, OPT_DEBUG_NONE + OO },
-    { "debug-all]", no_argument, NULL, OPT_DEBUG_ALL + OO },
-    { "debug-raw", no_argument, NULL, OPT_DEBUG_RAW + OO },
-    { "debug-crypt", no_argument, NULL, OPT_DEBUG_CRYPT + OO },
-    { "debug-parsing", no_argument, NULL, OPT_DEBUG_PARSING + OO },
-    { "debug-emitting", no_argument, NULL, OPT_DEBUG_EMITTING + OO },
-    { "debug-control", no_argument, NULL, OPT_DEBUG_CONTROL + OO },
-    { "debug-klips", no_argument, NULL, OPT_DEBUG_KLIPS + OO },
-    { "debug-private", no_argument, NULL, OPT_DEBUG_PRIVATE + OO },
+    { "debug-none", no_argument, NULL, DBGOPT_NONE + OO },
+    { "debug-all", no_argument, NULL, DBGOPT_ALL + OO },
+    { "debug-raw", no_argument, NULL, DBGOPT_RAW + OO },
+    { "debug-crypt", no_argument, NULL, DBGOPT_CRYPT + OO },
+    { "debug-parsing", no_argument, NULL, DBGOPT_PARSING + OO },
+    { "debug-emitting", no_argument, NULL, DBGOPT_EMITTING + OO },
+    { "debug-control", no_argument, NULL, DBGOPT_CONTROL + OO },
+    { "debug-klips", no_argument, NULL, DBGOPT_KLIPS + OO },
+    { "debug-private", no_argument, NULL, DBGOPT_PRIVATE + OO },
 #endif
-#   undef OO
+#undef OO
     { 0,0,0,0 }
 };
 
@@ -332,7 +392,7 @@
 
     if (life > limit)
     {
-	char buf[200];
+	char buf[200]; /* arbitrary limit */
 
 	snprintf(buf, sizeof(buf)
 	    , "%s [%lu seconds] must be less than %lu seconds"
@@ -341,7 +401,7 @@
     }
     if (life <= mint)
     {
-	char buf[200];
+	char buf[200]; /* arbitrary limit */
 
 	snprintf(buf, sizeof(buf)
 	    , "%s [%lu] must be greater than"
@@ -354,6 +414,7 @@
     }
 }
 
+
 /* This is a hack for initiating ISAKMP exchanges. */
 
 int
@@ -362,7 +423,8 @@
     struct whack_message msg;
     lset_t
 	opts_seen = LEMPTY,
-	opts_seen_before_to;
+	cd_seen = LEMPTY,
+	cd_seen_before_to;
     memset(&msg, '\0', sizeof(msg));
     msg.magic = WHACK_MAGIC;
     msg.right.host_port = IKE_UDP_PORT;
@@ -404,24 +466,41 @@
 		diagq("badly formed numeric argument", optarg);
 	}
 
-	/* all of our non-letter flags except OPT_DEBUG_* get
-	 * added to opts_seen.  The OP_DEBUG_* exception is because
-	 * we have too many to fit in a 32-bit string!
-	 * Unless other code intervenes, we reject repeated options.
-	 */
+	/* per-class option processing */
 
-	if (0 <= c
+       if (0 <= c && c <= OPT_LAST)
+       {
+           /* OPT_* options get added opts_seen.
+            * Reject repeated options (unless later code intervenes).
+            */
+           lset_t f = LELEM(c);
+ 
+           if (opts_seen & f)
+               diagq("duplicated flag", long_opts[long_index].name);
+           opts_seen |= f;
+       }
 #ifdef DEBUG
-	&& c < OPT_DEBUG_NONE
+       else if (DBGOPT_FIRST <= c && c <= DBGOPT_LAST)
+       {
+           /* DBGOPT_* options are treated separately to reduce
+            * potential members of opts_seen.
+            */
+           msg.whack_options = TRUE;
+       }
 #endif
-	)
-	{
-	    lset_t f = LELEM(c);
-
-	    if (opts_seen & f)
-		diagq("duplicated flag", long_opts[long_index].name);
-	    opts_seen |= f;
-	}
+       else if (CD_FIRST <= c && c <= CD_LAST)
+       {
+           /* CD_* options are added to cd_seen.
+            * Reject repeated options (unless later code intervenes).
+            */
+           lset_t f = LELEM(c - CD_FIRST);
+
+           if (cd_seen & f)
+             diagq("duplicated flag", long_opts[long_index].name);
+
+	       cd_seen |= f;
+		   opts_seen |= LELEM(OPT_CD);
+	   }
 
 	/* Note: "break"ing from switch terminates loop.
 	 * most cases should end with "continue".
@@ -469,77 +548,6 @@
 	    msg.name = optarg;
 	    continue;
 
-	case OPT_HOST:	/* --host <ip-address> */
-	    diagq(atoaddr(optarg, 0, &msg.right.host_addr), optarg);
-	    continue;
-
-	case OPT_ID:	/* --id <identity> */
-	    msg.right.id = optarg;	/* decoded by Pluto */
-	    continue;
-
-	case OPT_IKEPORT:	/* --ikeport <port-number> */
-	    if (opt_whole<=0 || opt_whole >= 0x10000)
-		diagq("<port-number> must be a number between 1 and 65535", optarg);
-	    msg.right.host_port = opt_whole;
-	    continue;
-
-	case OPT_NEXTHOP:	/* --nexthop <ip-address> */
-	    diagq(atoaddr(optarg, 0, &msg.right.host_nexthop), optarg);
-	    continue;
-
-	case OPT_CLIENT:	/* --client <subnet> */
-	    diagq(atosubnet(optarg, 0, &msg.right.client_net, &msg.right.client_mask), optarg);
-	    msg.right.has_client = TRUE;
-	    msg.policy |= POLICY_TUNNEL;	/* client => tunnel */
-	    continue;
-
-	case OPT_UPDOWN:	/* --updown <updown> */
-	    msg.right.updown = optarg;
-	    continue;
-
-
-	case OPT_TO:		/* --to */
-	    /* process right end, move it to left, reset it */
-	    if ((opts_seen & (LELEM(OPT_HOST) | LELEM(OPT_ID))) == 0)
-		diag("connection missing both --host and --id (before --to)");
-	    msg.left = msg.right;
-	    memset(&msg.right, '\0', sizeof(msg.right));
-	    msg.right.id = NULL;
-	    msg.right.updown = NULL;
-	    msg.right.host_port = IKE_UDP_PORT;
-	    opts_seen_before_to = opts_seen;
-	    opts_seen = (opts_seen & ~LRANGE(OPT_HOST,OPT_UPDOWN));
-	    continue;
-
-	case OPT_PSK:		/* --psk */
-	case OPT_RSASIG:	/* --rsasig */
-	case OPT_ENCRYPT:	/* --encrypt */
-	case OPT_AUTHENTICATE:	/* --authenticate */
-	case OPT_TUNNEL:	/* --tunnel */
-	case OPT_PFS:	/* -- pfs */
-	    msg.policy |= LELEM(c - OPT_POLICY_FIRST);
-	    continue;
-
-	case OPT_IKELIFETIME:	/* --ikelifetime <seconds> */
-	    msg.sa_ike_life_seconds = opt_whole;
-	    continue;
-
-	case OPT_IPSECLIFETIME:	/* --ipseclifetime <seconds> */
-	    msg.sa_ipsec_life_seconds = opt_whole;
-	    continue;
-
-	case OPT_RKMARGIN:	/* --rekeymargin <seconds> */
-	    msg.sa_rekey_margin = opt_whole;
-	    continue;
-
-	case OPT_RKFUZZ:	/* --rekeyfuzz <percentage> */
-	    msg.sa_rekey_fuzz = opt_whole;
-	    continue;
-
-	case OPT_KTRIES:	/* --keyingtries <count> */
-	    msg.sa_keying_tries = opt_whole;
-	    continue;
-
 	case OPT_KEYID:	/* --keyid <identity> */
 	    msg.whack_key = TRUE;
 	    msg.keyid = optarg;	/* decoded by Pluto */
@@ -548,7 +556,7 @@
 	case OPT_PUBKEYRSA:
 	    {
 		const char *ugh;
-		static char keyspace[1024];
+		static char keyspace[1024 + 4]; /* room for 8K bit key */
 
 		msg.pubkey_alg = PUBKEY_ALG_RSA;
 		ugh = atobytes(optarg, 0, keyspace, sizeof(keyspace), &msg.keyval.len);
@@ -604,26 +612,135 @@
 	    msg.whack_async = TRUE;
 	    continue;
 
+#ifdef OPENSSL
+	case OPT_CERTFILE:
+	    if (strlen(optarg) >= FILE_NAME_LIMIT)
+		diagq("certificate file name too long", optarg);
+		strcpy(msg.whack_certfile, optarg);
+        continue;
+
+	case OPT_CERTOPTS:
+	    if (strlen(optarg) >= CERT_OPTIONS_LIMIT)
+		diagq("certificate file name too long", optarg);
+		strcpy(msg.whack_certopts, optarg);
+        continue;
+
+	case OPT_PEERFILE:
+	    if (strlen(optarg) >= FILE_NAME_LIMIT)
+		diagq("peer certificate file name too long", optarg);
+		strcpy(msg.whack_peerfile, optarg);
+        continue;
+
+	case OPT_KEYFILE:
+	    if (strlen(optarg) >= FILE_NAME_LIMIT)
+		diagq("key file name too long", optarg);
+		strcpy(msg.whack_keyfile, optarg);
+        continue;
+
+	case OPT_CERTPATH:
+	    if (strlen(optarg) >= PATH_NAME_LIMIT)
+		diagq("certificate path name too long", optarg);
+		strcpy(msg.whack_certpath, optarg);
+        continue;
+#endif
+
+	/* Connection Description options */
+
+	case CD_HOST:	/* --host <ip-address> */
+	    diagq(atoaddr(optarg, 0, &msg.right.host_addr), optarg);
+	    continue;
+
+	case CD_ID:	/* --id <identity> */
+	    msg.right.id = optarg;	/* decoded by Pluto */
+	    continue;
+
+	case CD_IKEPORT:	/* --ikeport <port-number> */
+	    if (opt_whole<=0 || opt_whole >= 0x10000)
+		diagq("<port-number> must be a number between 1 and 65535", optarg);
+	    msg.right.host_port = opt_whole;
+	    continue;
+
+	case CD_NEXTHOP:	/* --nexthop <ip-address> */
+	    diagq(atoaddr(optarg, 0, &msg.right.host_nexthop), optarg);
+	    continue;
+
+	case CD_CLIENT:	/* --client <subnet> */
+	    diagq(atosubnet(optarg, 0, &msg.right.client_net, &msg.right.client_mask), optarg);
+	    msg.right.has_client = TRUE;
+	    msg.policy |= POLICY_TUNNEL;	/* client => tunnel */
+	    continue;
+
+	case CD_UPDOWN:	/* --updown <updown> */
+	    msg.right.updown = optarg;
+	    continue;
+
+
+	case CD_TO:		/* --to */
+	    /* process right end, move it to left, reset it */
+	    if ((opts_seen & (LELEM(CD_HOST-CD_FIRST) | LELEM(CD_ID-CD_FIRST))) == 0)
+		  diag("connection missing both --host and --id (before --to)");
+	    msg.left = msg.right;
+	    memset(&msg.right, '\0', sizeof(msg.right));
+	    msg.right.id = NULL;
+	    msg.right.updown = NULL;
+	    msg.right.host_port = IKE_UDP_PORT;
+	    cd_seen_before_to = cd_seen;
+	    cd_seen &= ~LRANGE(CD_HOST-CD_FIRST, CD_UPDOWN-CD_FIRST);
+	    continue;
+
+	case CD_PSK:		/* --psk */
+#ifndef OPENSSL
+	case CD_RSASIG:	/* --rsasig */
+#else
+	case CD_OPENSSL:	/* --rsasig */
+#endif
+	case CD_ENCRYPT:	/* --encrypt */
+	case CD_AUTHENTICATE:	/* --authenticate */
+	case CD_TUNNEL:	/* --tunnel */
+	case CD_PFS:	/* -- pfs */
+	    msg.policy |= LELEM(c - CD_POLICY_FIRST);
+	    continue;
+
+	case CD_IKELIFETIME:	/* --ikelifetime <seconds> */
+	    msg.sa_ike_life_seconds = opt_whole;
+	    continue;
+
+	case CD_IPSECLIFETIME:	/* --ipseclifetime <seconds> */
+	    msg.sa_ipsec_life_seconds = opt_whole;
+	    continue;
+
+	case CD_RKMARGIN:	/* --rekeymargin <seconds> */
+	    msg.sa_rekey_margin = opt_whole;
+	    continue;
+
+	case CD_RKFUZZ:	/* --rekeyfuzz <percentage> */
+	    msg.sa_rekey_fuzz = opt_whole;
+	    continue;
+
+	case CD_KTRIES:	/* --keyingtries <count> */
+	    msg.sa_keying_tries = opt_whole;
+	    continue;
+
 #ifdef DEBUG
-	case OPT_DEBUG_NONE:	/* --debug-none */
+	case DBGOPT_NONE:	/* --debug-none */
 	    msg.whack_options = TRUE;
 	    msg.debugging = DBG_NONE;
 	    continue;
 
-	case OPT_DEBUG_ALL:	/* --debug-all */
+	case DBGOPT_ALL:	/* --debug-all */
 	    msg.whack_options = TRUE;
 	    msg.debugging |= DBG_ALL;	/* note: does not include PRIVATE */
 	    continue;
 
-	case OPT_DEBUG_RAW:	/* --debug-raw */
-	case OPT_DEBUG_CRYPT:	/* --debug-crypt */
-	case OPT_DEBUG_PARSING:	/* --debug-parsing */
-	case OPT_DEBUG_EMITTING:	/* --debug-emitting */
-	case OPT_DEBUG_CONTROL:	/* --debug-control */
-	case OPT_DEBUG_KLIPS:	/* --debug-klips */
-	case OPT_DEBUG_PRIVATE:	/* --debug-private */
+	case DBGOPT_RAW:	/* --debug-raw */
+	case DBGOPT_CRYPT:	/* --debug-crypt */
+	case DBGOPT_PARSING:	/* --debug-parsing */
+	case DBGOPT_EMITTING:	/* --debug-emitting */
+	case DBGOPT_CONTROL:	/* --debug-control */
+	case DBGOPT_KLIPS:	/* --debug-klips */
+	case DBGOPT_PRIVATE:	/* --debug-private */
 	    msg.whack_options = TRUE;
-	    msg.debugging |= LELEM(c-OPT_DEBUG_RAW);
+	    msg.debugging |= LELEM(c-DBGOPT_RAW);
 	    continue;
 #endif
 	default:
@@ -640,25 +757,26 @@
      * required information was supplied.
      */
 
-    if (opts_seen & LRANGE(OPT_CD_FIRST, OPT_CD_LAST))
+//    if (opts_seen & LRANGE(CD_FIRST, CD_LAST))
+    if (opts_seen & LELEM(OPT_CD))
     {
-	if (!LALLIN(opts_seen, LELEM(OPT_TO)))
+	if (!LALLIN(cd_seen, LELEM(CD_TO-CD_FIRST)))
 	    diag("connection description option, but no --to");
 
-	if ((opts_seen & (LELEM(OPT_HOST) | LELEM(OPT_ID))) == 0)
+	if ((cd_seen & (LELEM(CD_HOST-CD_FIRST) | LELEM(CD_ID-CD_FIRST))) == 0)
 	    diag("connection missing both --host and --id (after --to)");
 
 	if (is_NO_IP(msg.left.host_addr)
-	&& is_NO_IP(msg.right.host_addr))
-	    diag("hosts cannot both be 0.0.0.0");
+	  && is_NO_IP(msg.right.host_addr))
+	  diag("hosts cannot both be 0.0.0.0");
 
-	if ((opts_seen_before_to & LELEM(OPT_NEXTHOP)) == 0)
+	if ((cd_seen_before_to & LELEM(CD_NEXTHOP-CD_FIRST)) == 0)
 	{
 	    if (is_NO_IP(msg.right.host_addr))
 		diag("left nexthop must be specified when right is Road Warrior");
 	    msg.left.host_nexthop = msg.right.host_addr;
 	}
-	if ((opts_seen & LELEM(OPT_NEXTHOP)) == 0)
+	if ((cd_seen & LELEM(CD_NEXTHOP-CD_FIRST)) == 0)
 	{
 	    if (is_NO_IP(msg.left.host_addr))
 		diag("right nexthop must be specified when left is Road Warrior");
@@ -671,7 +789,7 @@
     /* decide whether --name is mandatory or forbidden */
     if (opts_seen & (LELEM(OPT_ROUTE) | LELEM(OPT_UNROUTE)
     | LELEM(OPT_INITIATE) | LELEM(OPT_TERMINATE)
-    | LELEM(OPT_DELETE) | LELEM(OPT_TO)))
+    | LELEM(OPT_DELETE) | LELEM(OPT_CD)))
     {
 	if ((opts_seen & LELEM(OPT_NAME)) == 0)
 	    diag("missing --name <connection_name>");
@@ -761,7 +879,7 @@
 	/* for now, just copy reply back to stdout */
 
 	{
-	    char buf[4097];
+	    char buf[4097]; /* arbitrary limit on log line length */
 	    char *be = buf;
 
 	    for (;;)
diff -ruN freeswan-1.5.orig/pluto/whack.h freeswan-1.5/pluto/whack.h
--- freeswan-1.5.orig/pluto/whack.h	Sat Apr 15 04:56:04 2000
+++ freeswan-1.5/pluto/whack.h	Thu Oct  5 07:05:59 2000
@@ -14,6 +14,11 @@
  * RCSID $Id: whack.h,v 1.31 2000/04/15 08:56:04 dhr Exp $
  */
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+#include <freeswan.h>
+
 /*
  * Since the message remains on one host, native representation is used.
  * Think of this as horizontal microcode: all selected operations are
@@ -24,6 +29,7 @@
  * meaning, change this value (probably by changing the last number).
  */
 #define WHACK_MAGIC (('w' << 24) + ('h' << 16) + ('k' << 8) + 10)
+// #define WHACK_MAGIC (('w' << 24) + ('h' << 16) + ('k' << 8) + 12)
 
 /* struct whack_end is a lot like connection.h's struct end
  * It differs because it is going to be shipped down a socket
@@ -77,36 +83,42 @@
     enum pubkey_alg pubkey_alg;
     chunk_t keyval;	/* chunk */
 
-    /* for WHACK_ROUTE: */
+#ifdef OPENSSL
+// hm. Are the sizes necessary?
+//    char *whack_certfile;
+//    char *whack_certopts;
+//    char *whack_peerfile;
+//    char *whack_keyfile;
+//    char *whack_certpath;
+    char whack_certfile[FILE_NAME_LIMIT];
+    char whack_certopts[CERT_OPTIONS_LIMIT];
+    char whack_peerfile[FILE_NAME_LIMIT];
+    char whack_keyfile[FILE_NAME_LIMIT];
+    char whack_certpath[PATH_NAME_LIMIT];
+#endif
 
+    /* for WHACK_ROUTE: */
     bool whack_route;
 
     /* for WHACK_UNROUTE: */
-
     bool whack_unroute;
 
     /* for WHACK_INITIATE: */
-
     bool whack_initiate;
 
     /* for WHACK_TERMINATE: */
-
     bool whack_terminate;
 
     /* for WHACK_DELETE: */
-
     bool whack_delete;
 
     /* for WHACK_LISTEN: */
-
     bool whack_listen, whack_unlisten;
 
     /* for WHACK_STATUS: */
-
     bool whack_status;
 
     /* for WHACK_SHUTDOWN */
-
     bool whack_shutdown;
 
     /* space for strings (hope there is enough room):
@@ -117,7 +129,7 @@
      * 4 right's name [left.host.name.len]
      * 5 right's updown
      * 6 keyid
-     * plus keyval, a chunk.
+     * plus keyval  (limit: 8K bits + overhead), a chunk.
      */
     size_t str_size;
     char string[2048];
diff -ruN freeswan-1.5.orig/pluto/x_sobj.c freeswan-1.5/pluto/x_sobj.c
--- freeswan-1.5.orig/pluto/x_sobj.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/x_sobj.c	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,34 @@
+#include "x_sobj.h"
+
+IMPLEMENT_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *
+X509_OBJECT_new( const int type, void *p )
+{
+  X509_OBJECT *ret = Malloc(sizeof(X509_OBJECT));
+
+  if (ret == NULL) return ret;
+  switch(type) {
+  case X509_LU_X509:
+    ret->type = type;
+    ret->data.x509 = (X509 *)p;
+    break;
+  case X509_LU_CRL:
+    ret->type = type;
+    ret->data.crl = (X509_CRL *)p;
+    break;
+  default: /* Unknown type */
+    Free((char *)ret);
+    ret = NULL;
+    break;
+  }
+  return ret;
+}
+
+void
+X509_OBJECT_free(X509_OBJECT *x)
+{
+  if (!x) return;
+  X509_OBJECT_free_contents(x);
+  Free((char *)x);
+}
diff -ruN freeswan-1.5.orig/pluto/x_sobj.h freeswan-1.5/pluto/x_sobj.h
--- freeswan-1.5.orig/pluto/x_sobj.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/x_sobj.h	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,12 @@
+#ifndef X_SOBJ_H
+#define X_SOBJ_H
+
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+DECLARE_STACK_OF(X509_OBJECT)
+
+X509_OBJECT *X509_OBJECT_new( const int type, void *ptr );
+void X509_OBJECT_free(X509_OBJECT *x);
+
+#endif
diff -ruN freeswan-1.5.orig/pluto/xmap.c freeswan-1.5/pluto/xmap.c
--- freeswan-1.5.orig/pluto/xmap.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/xmap.c	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,249 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/stack.h>
+#include <openssl/asn1.h>
+#include <openssl/safestack.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+
+#include "x_sobj.h"
+#include "xmap_file.h"
+#include "xmap_dir.h"
+#include "xmap_db.h"
+#include "xmap_ldap.h"
+#include "xmap.h"
+
+#include "constants.h"
+#include "defs.h"
+#include "log.h"
+
+static XMAP_METHOD_LIST *xmth = NULL;
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+int
+XMAP_register(XMAP_METHOD *meth)
+{
+  XMAP_METHOD_LIST *p;
+  int found;
+  
+  for(p=xmth,found=0; ((!found) && (p)); p=p->next)
+    if (strcasecmp(meth->prefix, p->meth->prefix) == 0) found=1;
+
+  if (found) {
+    return 0;
+  } else {
+    p = malloc(sizeof(XMAP_METHOD_LIST));
+    if (p) {
+      p->next = xmth;
+      p->meth = meth;
+      xmth = p;
+    } else
+      return 0;
+  }
+  return 1;
+}
+
+void
+XMAP_METHOD_LIST_free( void )
+{
+  XMAP_METHOD_LIST *p, *q;
+
+  for(p=xmth; p;) {
+    q = p->next;
+    free(p);
+    q = p;
+  }
+}
+
+int
+XMAP_unregister(const char *prefix)
+{
+  XMAP_METHOD_LIST *p, *q;
+  int found;
+
+  for(p = xmth, found = 0; ((!found) && (p)); )
+    if (strcasecmp(p->meth->prefix, prefix) == 0)
+      found = 1;
+    else
+      p=p->next;
+
+  if (!found)
+    return 0;
+  else {
+    if ( p == xmth ) {
+      xmth = xmth->next;
+      free(p);
+    } else {
+      for(q = xmth; q->next != p; q = q->next);
+      q->next = p->next;
+      free(p);
+    }
+  }
+  return 1;
+}
+
+XMAP *
+XMAP_new(const char *spec)
+{
+  XMAP *ret;
+  char *s;
+
+  if ((ret = malloc(sizeof(XMAP))) == NULL) goto end;
+  if ((ret->spec = strdup(spec)) == NULL) goto end;
+  ret->methp = NULL;
+
+  if ((s = strchr(spec, DICT_SEPARATOR)) == NULL) {
+    log("No type prefix");
+  } else {
+    int l = (int)(s - spec) + 1;
+    XMAP_METHOD_LIST *p;
+    int found;
+
+    for(p=xmth, found = 0; ((!found) && (p));) {
+      if (strncasecmp(p->meth->prefix, spec, l-1) == 0)
+	found = 1;
+      else
+	p = p->next;
+    }
+
+    if (found) {
+      ret->pmap = p->meth->new(&s[1]);
+      if (! ret->pmap) goto end;
+      ret->methp = p;
+    } else {
+      log("Unknown map type spec: %s", spec);
+      goto end;
+    }
+  }
+  return ret;
+ end:
+  if (ret->spec) free(ret->spec);
+  if (ret) free(ret);
+  return NULL;
+}
+
+static int
+check_methp(XMAP *xm)
+{
+  XMAP_METHOD_LIST *p;
+
+  for(p = xmth; p; p = p->next)
+    if (xm->methp == p)
+      return 1;
+
+  return 0;
+}
+
+STACK_OF(X509_OBJECT) *
+XMAP_lookup( XMAP *xm, const int type, const char *index, void *p )
+{
+  if ((!xm) || (!check_methp(xm)) || (! xm->methp->meth->lookup) )
+  {
+	DBG(DBG_PARSING,
+    DBG_log("XMAP_lookup returns NULL.");
+	);
+    return NULL;
+  }
+  return xm->methp->meth->lookup(xm->pmap, type, index, p);
+}
+
+void
+XMAP_free(XMAP *xm)
+{
+  if (!xm) return;
+  if (!xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (xm->methp->meth->free) xm->methp->meth->free(xm->pmap);
+  if (xm->spec) free(xm->spec);
+  free(xm);
+}
+
+void
+XMAP_dump(XMAP *xm)
+{
+  if (! xm->pmap) return;
+  if (!check_methp(xm)) return;
+  if (! xm->methp->meth->dump) return;
+  xm->methp->meth->dump(xm->pmap);
+}
+
+int
+X509_subjAltName_check_dns(X509 *x, const char *dns)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+    if ((ext = X509_get_ext(x, loc)) != NULL) {
+      p = ext->value->data;
+      d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+      if (nsk) {
+	for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+	  gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+	  if (gn->type == GEN_DNS) {
+	    if (strncasecmp(dns, gn->d.ia5->data, gn->d.ia5->length) == 0) {
+	      ret = 1;
+	      break;
+	    }
+	  }
+	}
+	sk_GENERAL_NAME_free(nsk);
+	nsk = NULL;
+      }
+    }
+  }
+  return ret;
+}
+
+int
+X509_subjAltName_check_ip(X509 *x, const struct in_addr ip)
+{
+  int i, loc, ret;
+  X509_EXTENSION *ext;
+  u_char *p;
+  STACK_OF(GENERAL_NAME) *nsk = NULL;
+  GENERAL_NAME *gn;
+
+  ret = 0;
+  if ((loc = X509_get_ext_by_NID(x, NID_subject_alt_name, -1)) >= 0) {
+	if ((ext = X509_get_ext(x, loc)) != NULL) {
+		p = ext->value->data;
+		d2i_GENERAL_NAMES(&nsk, &p, ext->value->length);
+		if (nsk) {
+			for(i=0; i < sk_GENERAL_NAME_num(nsk); i++) {
+				gn = sk_GENERAL_NAME_value(nsk, i);
+	  
+				if (gn->type == GEN_IPADD) {
+					if (memcmp(&ip.s_addr, gn->d.ip->data, gn->d.ip->length) == 0) {
+						ret = 1;
+						break;
+					}
+				}
+			}
+			sk_GENERAL_NAME_free(nsk);
+			nsk = NULL;
+		}
+ 	 }
+  }
+  return ret;
+}
+
+IMPLEMENT_STACK_OF(XMAP)
diff -ruN freeswan-1.5.orig/pluto/xmap.h freeswan-1.5/pluto/xmap.h
--- freeswan-1.5.orig/pluto/xmap.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/xmap.h	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,56 @@
+#ifndef XMAP_H
+#define XMAP_H
+
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <openssl/safestack.h>
+#include <openssl/x509.h>
+#include <openssl/x509_vfy.h>
+
+#include "x_sobj.h"
+
+typedef struct _xmap_method_st {
+  char *prefix;
+    STACK_OF(X509_OBJECT) *(*lookup)( void *this, const int type, const char *index, void *p );
+  void (*dump)(void *pmap);
+  void (*free)(void *pmap);
+  void *(*new) (const char *spec);
+} XMAP_METHOD;
+
+typedef struct _xmap_method_list_st {
+  XMAP_METHOD *meth;
+  struct _xmap_method_list_st *next;
+} XMAP_METHOD_LIST;
+
+typedef struct _xmap_st {
+  char *spec;
+  void *pmap;
+  XMAP_METHOD_LIST *methp;
+} XMAP;
+
+DECLARE_STACK_OF(XMAP)
+
+#ifndef DICT_SEPARATOR
+#define DICT_SEPARATOR ':'
+#endif
+
+#define XMAP_UNKNOWN_TYPE 0
+#define XMAP_FILE_TYPE    1
+#define XMAP_DIR_TYPE     2
+#define XMAP_DB_TYPE      3
+
+int XMAP_register(XMAP_METHOD *meth);
+void XMAP_METHOD_LIST_free( void );
+int XMAP_unregister(const char *prefix);
+
+int X509_subjAltName_check_dns(X509 *x, const char *dns);
+int X509_subjAltName_check_ip(X509 *x, const struct in_addr in);
+
+XMAP *XMAP_new(const char *spec);
+STACK_OF(X509_OBJECT) *XMAP_lookup( XMAP *xm, const int type, const char *index, void *p );
+void XMAP_free(XMAP *xm);
+void XMAP_dump(XMAP *xm);
+
+#endif /* XMAP_H */
